open Gtk
open Gtk_mathview
open Tags
open GtkBase
open Gpointer

module MathView = struct
  let cast w : math_view obj = Object.try_cast w "GtkMathView"
  external create : Gtk.adjustment optobj -> Gtk.adjustment optobj ->
   math_view obj = "ml_gtk_math_view_new"
  let create ~adjustmenth ~adjustmentv () =
   create (optboxed adjustmenth) (optboxed adjustmentv)
  external load : [>`math_view] obj -> filename:string -> bool =
   "ml_gtk_math_view_load"
  external get_selection : [>`math_view] obj -> string option =
   "ml_gtk_math_view_get_selection"
  external unload : [>`math_view] obj -> unit =
   "ml_gtk_math_view_unload"
  external dump : [>`math_view] obj -> unit =
   "ml_gtk_math_view_dump"
  external get_width : [>`math_view] obj -> int =
   "ml_gtk_math_view_get_width"
  external get_height : [>`math_view] obj -> int =
   "ml_gtk_math_view_get_height"
  external set_adjustments : [>`math_view] obj -> Gtk.adjustment obj -> Gtk.adjustment obj -> unit =
   "ml_gtk_math_view_set_adjustments"
  external get_hadjustment : [>`math_view] obj -> Gtk.adjustment obj =
   "ml_gtk_math_view_get_hadjustment"
  external get_vadjustment : [>`math_view] obj -> Gtk.adjustment obj =
   "ml_gtk_math_view_get_vadjustment"
  external get_buffer : [>`math_view] obj -> Gdk.pixmap =
   "ml_gtk_math_view_get_buffer"
  external get_frame : [>`math_view] obj -> [`frame] obj =
   "ml_gtk_math_view_get_frame"
  external set_font_size : [>`math_view] obj -> int -> unit =
   "ml_gtk_math_view_set_font_size"
  (*external get_top : [>`math_view] obj -> (int * int) =
   "ml_gtk_math_view_get_top"
  external set_top : [>`math_view] obj -> int -> int -> unit =
   "ml_gtk_math_view_set_top"*)

  module Signals = struct
    open GtkSignal

    let jump : ([>`math_view],_) t =
     let marshal_jump f _ =
      function
         [GtkArgv.STRING (Some str)] -> f str
       | _ -> invalid_arg "GtkMathView.MathView.Signals.marshal_jump"
     in
      { name = "jump"; marshaller = marshal_jump }

    let clicked : ([>`math_view],_) t =
     let marshal_clicked f _ =
      function
         [] -> f ()
       | _ -> invalid_arg "GtkMathView.MathView.Signals.marshal_clicked"
     in
      { name = "clicked"; marshaller = marshal_clicked }
  end
end
